From 6812ace79b76b8dbfa1d7c5de0f4ebd19afea1ba Mon Sep 17 00:00:00 2001
From: Austin Seipp <aseipp@pobox.com>
Date: Fri, 23 Aug 2013 15:29:11 -0500
Subject: [PATCH] Fix i386/unix build.

Signed-off-by: Austin Seipp <aseipp@pobox.com>
---
 rts/Linker.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/rts/Linker.c b/rts/Linker.c
index b193149..4961ecf 100644
--- a/rts/Linker.c
+++ b/rts/Linker.c
@@ -2057,11 +2057,15 @@ void freeObjectCode (ObjectCode *oc)
         sysErrorBelch("munmap");
     }
 
+#if defined(powerpc_HOST_ARCH) || defined(x86_64_HOST_ARCH) || defined(arm_HOST_ARCH)
+#if !defined(x86_64_HOST_ARCH) || !defined(mingw32_HOST_OS)
     if (!USE_CONTIGUOUS_MMAP)
     {
         munmap(oc->symbol_extras,
                ROUND_UP(sizeof(SymbolExtra) * oc->n_symbol_extras, pagesize));
     }
+#endif
+#endif
 
 #else
 
@@ -2073,7 +2077,6 @@ void freeObjectCode (ObjectCode *oc)
 #endif
 #endif
 
-
 #endif
 
     stgFree(oc->fileName);
-- 
1.8.3

